/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import java.sql.Time;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zk.ui.event.InputEvent;
import org.zkoss.zkplus.databind.BindingListModelList;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Timebox;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.EsquemaCorrida;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.service.MarcaService;
import com.rjconsultores.ventaboletos.service.RutaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderConfiguracionCorrida;

/**
 * 
 * @author Rafius
 */
@Controller("busquedaCorridaController")
@Scope("prototype")
public class BusquedaCorridaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<EsquemaCorrida> plwEsquemaCorrida;
	@Autowired
	private MarcaService marcaService;
	@Autowired
	private ClaseServicioService claseService;
	@Autowired
	private RutaService rutaService;
	private MyListbox esquemaCorridaList;
	private Paging pagingEsquemaCorrida;
	private Datebox fecInicio;
	private Datebox fecFinal;
	private Combobox cmbClase;
	private Combobox cmbMarca;
	private Combobox cmbRuta;
	private Combobox cmbEmpresaCorrida;
	private List<Empresa> lsEmpresa;
	private List<Marca> lsMarca;
	private List<ClaseServicio> lsClase;
	private List<Ruta> lsRuta;
	private Button btnPesquisa;
	private Intbox txtID;
	private Intbox txtNumCorrida;
	private Timebox hora;

	public Combobox getCmbClase() {
		return cmbClase;
	}

	public void setCmbClase(Combobox cmbClase) {
		this.cmbClase = cmbClase;
	}

	public Combobox getCmbEmpresaCorrida() {
		return cmbEmpresaCorrida;
	}

	public void setCmbEmpresaCorrida(Combobox cmbEmpresaCorrida) {
		this.cmbEmpresaCorrida = cmbEmpresaCorrida;
	}

	public Combobox getCmbRuta() {
		return cmbRuta;
	}

	public void setCmbRuta(Combobox cmbRuta) {
		this.cmbRuta = cmbRuta;
	}

	public List<ClaseServicio> getLsClase() {
		return lsClase;
	}

	public void setLsClase(List<ClaseServicio> lsClase) {
		this.lsClase = lsClase;
	}

	public List<Empresa> getLsEmpresa() {
		return lsEmpresa;
	}

	public void setLsEmpresa(List<Empresa> lsEmpresa) {
		this.lsEmpresa = lsEmpresa;
	}

	public List<Marca> getLsMarca() {
		return lsMarca;
	}

	public void setLsMarca(List<Marca> lsMarca) {
		this.lsMarca = lsMarca;
	}

	public List<Ruta> getLsRuta() {
		return lsRuta;
	}

	public void setLsRuta(List<Ruta> lsRuta) {
		this.lsRuta = lsRuta;
	}

	public Paging getPagingEsquemaCorrida() {
		return pagingEsquemaCorrida;
	}

	public void setPagingEsquemaCorrida(Paging pagingEsquemaCorrida) {
		this.pagingEsquemaCorrida = pagingEsquemaCorrida;
	}

	public MyListbox getEsquemaCorridaList() {
		return esquemaCorridaList;
	}

	public void setEsquemaCorridaList(MyListbox esquemaCorridaList) {
		this.esquemaCorridaList = esquemaCorridaList;
	}

	public PagedListWrapper<EsquemaCorrida> getPlwEsquemaCorrida() {
		return plwEsquemaCorrida;
	}

	public void setPlwEsquemaCorrida(PagedListWrapper<EsquemaCorrida> plwEsquemaCorrida) {
		this.plwEsquemaCorrida = plwEsquemaCorrida;
	}

	public Datebox getFecFinal() {
		return fecFinal;
	}

	public void setFecFinal(Datebox fecFinal) {
		this.fecFinal = fecFinal;
	}

	public Datebox getFecInicio() {
		return fecInicio;
	}

	public void setFecInicio(Datebox fecInicio) {
		this.fecInicio = fecInicio;
	}

	public Button getBtnPesquisa() {
		return btnPesquisa;
	}

	public void setBtnPesquisa(Button btnPesquisa) {
		this.btnPesquisa = btnPesquisa;
	}

	public Combobox getCmbMarca() {
		return cmbMarca;
	}

	public void setCmbMarca(Combobox cmbMarca) {
		this.cmbMarca = cmbMarca;
	}

	public Intbox getTxtID() {
		return txtID;
	}

	public void setTxtID(Intbox txtID) {
		this.txtID = txtID;
	}

	public Timebox getHora() {
		return hora;
	}

	public void setHora(Timebox hora) {
		this.hora = hora;
	}
	

	public void onChange$cmbMarca(InputEvent ev) {

		if (ev.isChangingBySelectBack()) {
			return;
		}
		lsRuta = rutaService.obtenerPorEmpresa(((Marca) cmbMarca.getSelectedItem().getValue()).getEmpresa());
		BindingListModelList l = new BindingListModelList(lsRuta, true);
		cmbRuta.setModel(l);
		cmbRuta.setSelectedItem(null);
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		lsEmpresa = UsuarioLogado.getUsuarioLogado().getEmpresa();
		lsMarca = marcaService.buscarMarcaPorEmpresa(UsuarioLogado.getUsuarioLogado().getEmpresa());
		lsClase = claseService.obtenerTodos();
		lsRuta = rutaService.obtenerTodos();

		esquemaCorridaList.setItemRenderer(new RenderConfiguracionCorrida());
		esquemaCorridaList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				EsquemaCorrida rc = (EsquemaCorrida) esquemaCorridaList.getSelected();
				verPeriodo(rc);
			}
		});

		btnPesquisa.focus();
		cmbMarca.setSelectedItem(null);

		refreshLista();
	}

	private void verPeriodo(EsquemaCorrida rc) {
		if (rc == null) {
			return;
		}

		Map args = new HashMap();
		args.put("esquemaCorrida", rc);
		args.put("busquedaCorridaController", this);
		args.put("esquemaCorridaList", esquemaCorridaList);

		openWindow("/gui/esquema_operacional/editarCorrida.zul",
				Labels.getLabel("editarConfiguracionCorridaController.window.title"), args, MODAL);
	}

	public void onClick$btnPesquisa(Event ev) throws InterruptedException {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verPeriodo(new EsquemaCorrida());
	}

	public void refreshLista() {
		HibernateSearchObject<EsquemaCorrida> busquedaCorrita =
				new HibernateSearchObject<EsquemaCorrida>(EsquemaCorrida.class,
						pagingEsquemaCorrida.getPageSize());

		busquedaCorrita.addFilterEqual("activo", Boolean.TRUE);

		Integer id = txtID.getValue();
		busquedaCorrita.addFilterEqual("esquemacorridaId", id);

		Integer numCorrida = txtNumCorrida.getValue();
		busquedaCorrita.addFilterEqual("numCorrida", numCorrida);

		Date dtHora = hora.getValue();
		if (dtHora != null) {
			Time time = new Time(dtHora.getTime());
			busquedaCorrita.addFilterEqual("horasalida", time);
		}

		Comboitem cbiClase = cmbClase.getSelectedItem();
		ClaseServicio claseServicio = null;
		if (cbiClase != null) {
			claseServicio = (ClaseServicio) cbiClase.getValue();
			busquedaCorrita.addFilterEqual("claseServicio", claseServicio);
		}

		Comboitem cbiMarca = cmbMarca.getSelectedItem();
		Marca marca = null;
		if (cbiMarca != null) {
			marca = (Marca) cbiMarca.getValue();
			busquedaCorrita.addFilterEqual("marca", marca);
		}

		Comboitem cbiRuta = cmbRuta.getSelectedItem();
		Ruta ruta = null;
		if (cbiRuta != null) {
			ruta = (Ruta) cbiRuta.getValue();
			busquedaCorrita.addFilterEqual("ruta", ruta);
		}

		Comboitem cbiEmpresa = cmbEmpresaCorrida.getSelectedItem();
		Empresa empresa = null;
		if (cbiEmpresa != null) {
			empresa = (Empresa) cbiEmpresa.getValue();
			busquedaCorrita.addFilterEqual("empresa", empresa);
		} else {
			busquedaCorrita.addFilterIn("empresa", lsEmpresa);
		}

		if (fecInicio.getValue() != null) {
			Date ini = fecInicio.getValue();
			ini.setHours(00);
			ini.setMinutes(00);
			ini.setSeconds(00);
			busquedaCorrita.addFilterGreaterOrEqual("esquemaOperacional.fecniciovigencia",
					ini);
		}

		if (fecFinal.getValue() != null) {
			Date fin = fecFinal.getValue();
			fin.setHours(23);
			fin.setMinutes(59);
			fin.setSeconds(59);
			busquedaCorrita.addFilterLessOrEqual("esquemaOperacional.fecfinvigencia",
					fin);
		}
		busquedaCorrita.addSortDesc("esquemacorridaId");

		plwEsquemaCorrida.init(busquedaCorrita, esquemaCorridaList, pagingEsquemaCorrida);

		if (esquemaCorridaList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaConfiguracionCorridaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}
}
